// C Source File
// Created 8/14/2001; 4:49:16 PM
//to handle the choice if it is variations
#include "declerations.h"
void varhand (int result)//for handling the result if it is a variation
{//a1 b1 / a2 b2 / =
	ESI ptr;
	int width, top, bottom, size, extrawidth;
	HANDLE popuphandle = PopupNew ("Solve For:", 0), 
		dialoghandle = H_NULL;
	enum {A1 = 1, B1, C1};
	char *a1value;
	char *b1value;
	char *c1value;
	char *a2value;
	char *b2value;
	char *c2value;
	char rawvalues[100] = {};
	int lcd_width = LCD_WIDTH, ti92plus = TI92PLUS;
	if (ti92plus)
	{
		extrawidth = 10;
	}
	else
	{
		extrawidth = 0;
	}
	if ((result == DIRECT) || (result ==INVERSE))
	{
		dialoghandle = DialogNewSimple (125 + 4 * extrawidth, 54 + extrawidth);
	}
	else
	{
		dialoghandle = DialogNewSimple (155 + extrawidth/2, 54 + extrawidth);
	}
	switch (result)//result passed to it
	{
  case (DIRECT)://if direct
  	push_END_TAG ();
  	push_parse_text ("a1/b1=a2/b2");//pretty print the expression
  	NG_rationalESI (top_estack);
		WinClr (DeskTop);
		Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom, &top);
	  size = top + bottom;
	  Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 20 + top);//pretty print
	  FontSetSys (ti92plus);
  	PopupAddText (popuphandle, -1, "a1", A1);//solve in a popup
  	PopupAddText (popuphandle, -1, "b1", B1);
  	result = PopupDo (popuphandle, CENTER, 32 + size, 0); 
  	HeapFree (popuphandle);//right after so no possible memory leak
  	popuphandle = H_NULL;
		DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
		switch (result)
		{//do dialog for numbers.
		case (A1)://if a1, then add title enter values with 2 buttons, add
			DialogAddRequest (dialoghandle, 3, 14, "b1 = ", 0, 19, 8);//request to
//it, at pos 3 pix to right of side of box, 10 pix down from top, with prompt
//b1 = store at ofset 0, with max length 8 characters and width 48 pix
			DialogAddRequest (dialoghandle, 3,24+2 * ti92plus, "a2 = ", 20, 19, 8);
			DialogAddRequest (dialoghandle, 3,34+4 * ti92plus, "b2 = ", 40, 19, 8);
			if (DialogDo (dialoghandle, CENTER, 20 + size, rawvalues, NULL) ==
				KEY_ENTER)
			{//actually show dialogbox associated with handle dialoghandle,
//center x cord, 40+ size down, store request box values into rawvalues, no
//popdown menu values.
				b1value = rawvalues;
				a2value = rawvalues + 20;
				b2value = rawvalues + 40;
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
				push_END_TAG();//set up solve routine in RPN
				push_quantum_pair (VAR_NAME_TAG, 'a');//var tag (to solve for)
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (a2value);
				push_parse_text (b2value);
				push_quantum (DIV_TAG);//dividing them (a2/b2)
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (b1value);
				push_quantum_pair (DIV_TAG, EQ_TAG);//divide them (a1/b1),
				//make equal (a2/b2=a1/b1)
				push_quantum (SOLVE_TAG);//solve (a2/b2=a1/b1,a1)
				NG_rationalESI (top_estack);//actually do it
				Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom,
					&top);//get the size for pretty printing
  			Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 50 + top);
  			ngetchx();
			}
			else
			{
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
			}
			break;
		case (B1)://like above
			DialogAddRequest (dialoghandle, 3, 14, "a1 = ", 0, 19, 8);
			DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus, "a2 = ", 20, 19, 8);
			DialogAddRequest (dialoghandle, 3, 34 + 4*ti92plus, "b2 = ", 40, 19, 8);
			if (DialogDo (dialoghandle, CENTER, 20 + size, rawvalues, NULL) ==
				KEY_ENTER)
				{
					a1value = rawvalues;
					a2value = rawvalues + 20;
					b2value = rawvalues + 40;
					HeapFree (dialoghandle);
					dialoghandle = H_NULL;
					push_END_TAG();//END_TAG X a1 X / a2 b2 / = solvetag
					push_quantum_pair (VAR_NAME_TAG, 'b');
					push_quantum_pair ('1', VAR_NAME_TAG);
					push_parse_text (a1value);
					push_quantum_pair (VAR_NAME_TAG, 'b');
					push_quantum_pair ('1', VAR_NAME_TAG);
					push_quantum (DIV_TAG);
					push_parse_text (a2value);//whatever the user enters is valid, not
					push_parse_text (b2value);//just ints
					push_quantum_pair (DIV_TAG, EQ_TAG);
					push_quantum (SOLVE_TAG);
					NG_rationalESI (top_estack);
					Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom,
						&top);//get the size for pretty printing
  				Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 50 + top);
  				ngetchx();
				}
				else
				{
					HeapFree (dialoghandle);
					dialoghandle = H_NULL;
				}
		}
		break;
	case (INVERSE):
		push_END_TAG ();
  	push_parse_text ("a1*b1=a2*b2");
  	NG_rationalESI (top_estack);
		WinClr (DeskTop);
		Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom, &top);
	  size = top + bottom;
	  Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 20 + top);//pretty print
	  FontSetSys (ti92plus);
  	PopupAddText (popuphandle, -1, "a1", A1);//solve in a popup
  	PopupAddText (popuphandle, -1, "b1", B1);
  	result = PopupDo (popuphandle, CENTER, 32 + size, 0);
  	HeapFree (popuphandle);
  	popuphandle = H_NULL;
		DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
		switch (result)
		{
		case (A1):
			DialogAddRequest (dialoghandle, 3, 14, "b1 = ", 0, 19, 8);
			DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus, "a2 = ", 20, 19, 8);
			DialogAddRequest (dialoghandle, 3, 34 + 4*ti92plus, "b2 = ", 40, 19, 8);
			if (DialogDo (dialoghandle, CENTER, 30 + size, rawvalues, NULL) ==
				KEY_ENTER)
			{
				b1value = rawvalues;
				a2value = rawvalues + 20;
				b2value = rawvalues + 40;
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
				push_END_TAG();//a2, b2, MUL_TAG, EQ_TAG, SOLVE_TAG
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (b1value);
				push_quantum (MUL_TAG);
				push_parse_text (a2value);
				push_parse_text (b2value);
				push_quantum_pair (MUL_TAG, EQ_TAG);
				push_quantum (SOLVE_TAG);
				NG_rationalESI (top_estack);
				Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom,
						&top);//get the size for pretty printing
  			Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 50 + top);
  			ngetchx();
			}
			else
			{
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
			}
			break;
		case (B1):
			DialogAddRequest (dialoghandle, 3, 14, "a1 = ", 0, 19, 8);
			DialogAddRequest (dialoghandle, 3, 24 + 2*ti92plus, "a2 = ", 20, 19, 8);
			DialogAddRequest (dialoghandle, 3, 34 + 4*ti92plus, "b2 = ", 40, 19, 8);
			if (DialogDo (dialoghandle, CENTER, 30 + size, rawvalues, NULL) ==
				KEY_ENTER)
			{
				a1value = rawvalues;
				a2value = rawvalues + 20;
				b2value = rawvalues + 40;
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
				push_END_TAG();//b2, MUL_TAG, EQ_TAG, SOLVE_TAG
				push_quantum_pair (VAR_NAME_TAG, 'b');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (a1value);
				push_quantum_pair (VAR_NAME_TAG, 'b');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_quantum (MUL_TAG);
				push_parse_text (a2value);
				push_parse_text (b2value);
				push_quantum_pair (MUL_TAG, EQ_TAG);
				push_quantum (SOLVE_TAG);
				NG_rationalESI (top_estack);
				Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom,
						&top);
				Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 50 + top);
  			ngetchx();
			}
			else
			{
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
			}
		}
		break;
	case (JOINT):
		push_END_TAG ();
  	push_parse_text ("a1/(b1*d1)=a2/(b2*d2)");
  	NG_rationalESI (top_estack);
		WinClr (DeskTop);
		Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom, &top);
	  size = top + bottom;
	  Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 20 + top);//pretty print
	  FontSetSys (ti92plus);
		PopupAddText (popuphandle, -1, "a1", A1);//solve in a popup
  	PopupAddText (popuphandle, -1, "b1", B1);
  	result = PopupDo (popuphandle, CENTER, 32 + size, 0);
  	HeapFree (popuphandle);
  	popuphandle = H_NULL;
		DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
		switch (result)
		{
		case (A1):
			DialogAddRequest (dialoghandle, 1, 14, "b1=", 0, 19, 8);
			DialogAddRequest (dialoghandle, 1, 24 + 2 * ti92plus, "d1=", 20, 19, 8);
			DialogAddRequest (dialoghandle, 1, 34 + 4 * ti92plus, "a2=", 40, 19, 8);
			DialogAddRequest (dialoghandle, 70 + extrawidth, 14, "b2=", 60, 19, 8);
			DialogAddRequest (dialoghandle, 70 + extrawidth, 24 + 2 * ti92plus,
				"d2=", 80, 19, 8);
			if (DialogDo (dialoghandle, CENTER, 20 + size, rawvalues, NULL) ==
				KEY_ENTER)
			{
				b1value = rawvalues;
				c1value = rawvalues + 20;
				a2value = rawvalues + 40;
				b2value = rawvalues + 60;
				c2value = rawvalues + 80;
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
				push_END_TAG();//SOLVE_TAG
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (b1value);
				push_parse_text (c1value);
				push_quantum_pair (MUL_TAG, DIV_TAG);
				push_parse_text (a2value);
				push_parse_text (b2value);
				push_parse_text (c2value);
				push_quantum_pair (MUL_TAG, DIV_TAG);
				push_quantum_pair (EQ_TAG, SOLVE_TAG);
				NG_rationalESI (top_estack);
				Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom,
						&top);
				Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 50 + top);
  			ngetchx();
			}
			else
			{
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
			}
			break;
		case (B1):
			DialogAddRequest (dialoghandle, 1, 14, "a1=", 0, 19, 8);
			DialogAddRequest (dialoghandle, 1, 24 + 2 * ti92plus, "d1=", 20, 19, 8);
			DialogAddRequest (dialoghandle, 1, 34 + 4 * ti92plus, "a2=", 40, 19, 8);
			DialogAddRequest (dialoghandle, 70 + extrawidth, 14, "b2=", 60, 19, 8);
			DialogAddRequest (dialoghandle, 70 + extrawidth, 24 + 2 * ti92plus,
				"d2=", 80, 19, 8);
			if (DialogDo (dialoghandle, CENTER, 20 + size, rawvalues, NULL) ==
				KEY_ENTER)
			{
				a1value = rawvalues;
				c1value = rawvalues + 20;
				a2value = rawvalues + 40;
				b2value = rawvalues + 60;
				c2value = rawvalues + 80;
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
				push_END_TAG();//SOLVE_TAG
				push_quantum_pair (VAR_NAME_TAG, 'b');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (a1value);
				push_quantum_pair (VAR_NAME_TAG, 'b');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (c1value);
				push_quantum_pair (MUL_TAG, DIV_TAG);
				push_parse_text (a2value);
				push_parse_text (b2value);
				push_parse_text (c2value);
				push_quantum_pair (MUL_TAG, DIV_TAG);
				push_quantum_pair (EQ_TAG, SOLVE_TAG);
				NG_rationalESI (top_estack);
				Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom,
						&top);
				Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 50 + top);
  			ngetchx();
  		}
  		else
  		{
  			HeapFree (dialoghandle);
  			dialoghandle = H_NULL;
  		}
		}
		break;
	case (COMBINED):
		push_END_TAG ();
  	push_parse_text ("a1*b1/d1=a2*b2/d2");
  	NG_rationalESI (top_estack);
		WinClr (DeskTop);
		Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom, &top);
	  size = top + bottom;
	  Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 20 + top);
	  FontSetSys (ti92plus);
		PopupAddText (popuphandle, -1, "a1", A1);
  	PopupAddText (popuphandle, -1, "d1", C1);
  	result = PopupDo (popuphandle, CENTER, 32 + size, 0);
  	HeapFree (popuphandle);
  	popuphandle = H_NULL;
		DialogAddTitle (dialoghandle, "Enter Values", BT_OK, BT_CANCEL);
		switch (result)
		{
		case (A1):
			DialogAddRequest (dialoghandle, 1, 14, "b1=", 0, 19, 8);
			DialogAddRequest (dialoghandle, 1, 24 + 2 * ti92plus, "d1=", 20, 19, 8);
			DialogAddRequest (dialoghandle, 1, 34 + 4 * ti92plus, "a2=", 40, 19, 8);
			DialogAddRequest (dialoghandle, 70 + extrawidth, 14, "b2=", 60, 19, 8);
			DialogAddRequest (dialoghandle, 70 + extrawidth, 24 + 2 * ti92plus,
				"d2=", 80, 19, 8);
			if (DialogDo (dialoghandle, CENTER, 20 + size, rawvalues, NULL) ==
				KEY_ENTER)
			{
				b1value = rawvalues;
				c1value = rawvalues + 20;
				a2value = rawvalues + 40;
				b2value = rawvalues + 60;
				c2value = rawvalues + 80;
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
				push_END_TAG();
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (b1value);
				push_quantum (MUL_TAG);
				push_parse_text (c1value);
				push_quantum (DIV_TAG);
				push_parse_text (a2value);
				push_parse_text (b2value);
				push_quantum (MUL_TAG);
				push_parse_text (c2value);
				push_quantum_pair (DIV_TAG, EQ_TAG);
				push_quantum (SOLVE_TAG);
				NG_rationalESI (top_estack);
				Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom,
						&top);
				Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 50 + top);
  			ngetchx();	
			}
			else
			{
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
			}
			break;
		case (C1):
			DialogAddRequest (dialoghandle, 1, 14, "a1=", 0, 19, 8);
			DialogAddRequest (dialoghandle, 1, 24 + 2 * ti92plus, "b1=", 20, 19, 8);
			DialogAddRequest (dialoghandle, 1, 34 + 4 * ti92plus, "a2=", 40, 19, 8);
			DialogAddRequest (dialoghandle, 70 + extrawidth, 14, "b2=", 60, 19, 8);
			DialogAddRequest (dialoghandle, 70 + extrawidth, 24 + 4 * ti92plus,
				"d2=", 80, 19, 8);
			if (DialogDo (dialoghandle, CENTER, 20 + size, rawvalues, NULL) ==
				KEY_ENTER)
			{
				a1value = rawvalues;
				b1value = rawvalues + 20;
				a2value = rawvalues + 40;
				b2value = rawvalues + 60;
				c2value = rawvalues + 80;
				HeapFree (dialoghandle);
				dialoghandle = H_NULL;
				push_END_TAG();//SOLVE_TAG
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_parse_text (a1value);
				push_quantum_pair (VAR_NAME_TAG, 'a');
				push_quantum_pair ('1', VAR_NAME_TAG);
				push_quantum (MUL_TAG);
				push_parse_text (b1value);
				push_quantum (DIV_TAG);
				push_parse_text (a2value);
				push_parse_text (b2value);
				push_quantum (MUL_TAG);
				push_parse_text (c2value);
				push_quantum_pair (DIV_TAG, EQ_TAG);
				push_quantum (SOLVE_TAG);
				NG_rationalESI (top_estack);
				Parms2D ((ptr = Parse2DExpr (top_estack, FALSE)), &width, &bottom,
						&top);
				Print2DExpr (ptr, DeskTop, (lcd_width - width)/2, 50 + top);
  			ngetchx();
  		}
  		else
  		{
  			HeapFree (dialoghandle);
  			dialoghandle = H_NULL;
  		}
		}
		break;
	}
	if (popuphandle)
	{
		HeapFree (popuphandle);
		popuphandle = H_NULL;
	}
	if (dialoghandle)
	{
		HeapFree (dialoghandle);
		dialoghandle = H_NULL;
	}
	clrscr();
}
